Index: src/data/sys-file-reader.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/sys-file-reader.c,v
retrieving revision 1.26
diff -u -p -r1.26 sys-file-reader.c
--- src/data/sys-file-reader.c	25 Nov 2006 02:15:00 -0000	1.26
+++ src/data/sys-file-reader.c	5 Dec 2006 06:36:36 -0000
@@ -346,7 +346,7 @@ sfm_open_reader (struct file_handle *fh,
 	lose ((ME,
                _("%s: Weighting variable may not be a continuation of "
 		 "a long string variable."), fh_get_file_name (fh)));
-      else if (weight_var->type == ALPHA)
+      else if (var_is_alpha (weight_var))
 	lose ((ME, _("%s: Weighting variable may not be a string variable."),
 	       fh_get_file_name (fh)));
 
@@ -465,9 +465,9 @@ sfm_open_reader (struct file_handle *fh,
 
 		      v = dict_get_var(*dict, i);
 
-		      v->measure = params.measure;
-		      v->display_width = params.width;
-		      v->alignment = params.align;
+		      var_set_measure (v, params.measure);
+		      var_set_display_width (v, params.width);
+		      var_set_alignment (v, params.align);
 		    }
 		}
 		break;
@@ -630,10 +630,10 @@ sfm_open_reader (struct file_handle *fh,
 				}
 
 			      l = length;
-			      if ( v->width > EFFECTIVE_LONG_STRING_LENGTH ) 
+			      if ( var_get_width (v) > EFFECTIVE_LONG_STRING_LENGTH ) 
 				l -= EFFECTIVE_LONG_STRING_LENGTH;
 			      else
-				l -= v->width;
+				l -= var_get_width (v);
 
 			      idx = v->index;
 			      while ( l > 0 ) 
@@ -641,20 +641,17 @@ sfm_open_reader (struct file_handle *fh,
 				  struct variable *v_next;
 				  v_next = dict_get_var(*dict, idx + 1);
 
-				  if ( v_next->width > EFFECTIVE_LONG_STRING_LENGTH ) 
+				  if ( var_get_width (v_next) > EFFECTIVE_LONG_STRING_LENGTH ) 
 				    l -= EFFECTIVE_LONG_STRING_LENGTH;
 				  else
-				    l -= v_next->width;
+				    l -= var_get_width (v_next);
 
 				  dict_delete_var(*dict, v_next);
 				}
 
 			      assert ( length > MAX_LONG_STRING );
 
-			      v->width = length;
-			      v->print.w = v->width;
-			      v->write.w = v->width;
-			      v->nv = DIV_RND_UP (length, MAX_SHORT_STRING);
+                              var_set_width (v, length);
 			    }
 			  eq_seen = false;
 			  memset(name, 0, SHORT_NAME_LEN+1); 
@@ -725,7 +722,7 @@ sfm_open_reader (struct file_handle *fh,
       {
         struct variable *v = dict_get_var (*dict, i);
         struct sfm_var *sv = &r->vars[i];
-        sv->width = v->width;
+        sv->width = var_get_width (v);
         sv->fv = v->fv; 
       }
   }
@@ -1015,6 +1012,8 @@ read_variables (struct sfm_reader *r,
       char name[SHORT_NAME_LEN + 1];
       int nv;
       int j;
+      struct fmt_spec print, write;
+
 
       assertive_buf_read (r, &sv, sizeof sv, 0);
 
@@ -1101,7 +1100,7 @@ read_variables (struct sfm_reader *r,
                fh_get_file_name (r->fh), name));
 
       /* Set the short name the same as the long name */
-      var_set_short_name (vv, vv->name);
+      var_set_short_name (vv, var_get_name (vv));
 
       /* Case reading data. */
       nv = sv.type == 0 ? 1 : DIV_RND_UP (sv.type, sizeof (flt64));
@@ -1123,15 +1122,16 @@ read_variables (struct sfm_reader *r,
 	  if (len < 0 || len > 255)
 	    lose ((ME, _("%s: Variable %s indicates variable label of invalid "
                          "length %d."),
-                   fh_get_file_name (r->fh), vv->name, len));
+                   fh_get_file_name (r->fh), var_get_name (vv), len));
 
 	  if ( len != 0 ) 
 	    {
 	      /* Read label into variable structure. */
-	      vv->label = buf_read (r, NULL, ROUND_UP (len, sizeof (int32_t)), len + 1);
-	      if (vv->label == NULL)
-		goto error;
-	      vv->label[len] = '\0';
+	      char label[256];
+              assertive_buf_read (r, label, ROUND_UP (len, sizeof (int32_t)),
+                                  0);
+	      label[len] = '\0';
+              var_set_label (vv, label);
 	    }
 	}
 
@@ -1140,48 +1140,54 @@ read_variables (struct sfm_reader *r,
 	{
 	  flt64 mv[3];
           int mv_cnt = abs (sv.n_missing_values);
+          struct missing_values miss;
 
-	  if (vv->width > MAX_SHORT_STRING)
+	  if (var_get_width (vv) > MAX_SHORT_STRING)
 	    lose ((ME, _("%s: Long string variable %s may not have missing "
                          "values."),
-                   fh_get_file_name (r->fh), vv->name));
+                   fh_get_file_name (r->fh), var_get_name (vv)));
+          mv_init (&miss, var_get_width (vv));
 
 	  assertive_buf_read (r, mv, sizeof *mv * mv_cnt, 0);
 
-	  if (r->reverse_endian && vv->type == NUMERIC)
+	  if (r->reverse_endian && var_is_numeric (vv))
 	    for (j = 0; j < mv_cnt; j++)
 	      bswap_flt64 (&mv[j]);
 
 	  if (sv.n_missing_values > 0)
 	    {
               for (j = 0; j < sv.n_missing_values; j++)
-                if (vv->type == NUMERIC)
-                  mv_add_num (&vv->miss, mv[j]);
+                if (var_is_numeric (vv))
+                  mv_add_num (&miss, mv[j]);
                 else
-                  mv_add_str (&vv->miss, (char *) &mv[j]);
+                  mv_add_str (&miss, (char *) &mv[j]);
 	    }
 	  else
 	    {
-	      if (vv->type == ALPHA)
+	      if (var_is_alpha (vv))
 		lose ((ME, _("%s: String variable %s may not have missing "
                              "values specified as a range."),
-                       fh_get_file_name (r->fh), vv->name));
+                       fh_get_file_name (r->fh), var_get_name (vv)));
 
 	      if (mv[0] == r->lowest)
-                mv_add_num_range (&vv->miss, LOWEST, mv[1]);
+                mv_add_num_range (&miss, LOWEST, mv[1]);
 	      else if (mv[1] == r->highest)
-                mv_add_num_range (&vv->miss, mv[0], HIGHEST);
+                mv_add_num_range (&miss, mv[0], HIGHEST);
 	      else
-                mv_add_num_range (&vv->miss, mv[0], mv[1]);
+                mv_add_num_range (&miss, mv[0], mv[1]);
 
 	      if (sv.n_missing_values == -3)
-                mv_add_num (&vv->miss, mv[2]);
+                mv_add_num (&miss, mv[2]);
 	    }
+          var_set_missing_values (vv, &miss);
 	}
 
-      if (!parse_format_spec (r, sv.print, &vv->print, vv)
-	  || !parse_format_spec (r, sv.write, &vv->write, vv))
+      if (!parse_format_spec (r, sv.print, &print, vv)
+	  || !parse_format_spec (r, sv.write, &write, vv))
 	goto error;
+
+      var_set_print_format (vv, &print);
+      var_set_write_format (vv, &write);
     }
 
   /* Some consistency checks. */
@@ -1216,27 +1222,27 @@ parse_format_spec (struct sfm_reader *r,
   f->w = (s >> 8) & 0xff;
   f->d = s & 0xff;
 
-  if ((v->type == ALPHA) ^ (fmt_is_string (f->type) != 0))
+  if (var_is_alpha (v) != fmt_is_string (f->type))
     lose ((ME, _("%s: %s variable %s has %s format specifier %s."),
 	   fh_get_file_name (r->fh),
-           v->type == ALPHA ? _("String") : _("Numeric"),
-	   v->name,
+           var_is_alpha (v) ? _("String") : _("Numeric"),
+	   var_get_name (v),
 	   fmt_is_string (f->type) ? _("string") : _("numeric"),
 	   fmt_name (f->type)));
 
   msg_disable ();
-  ok = fmt_check_output (f) && fmt_check_width_compat (f, v->width);
+  ok = fmt_check_output (f) && fmt_check_width_compat (f, var_get_width (v)); 
   msg_enable ();
   
   if (!ok) 
     {
       char fmt_string[FMT_STRING_LEN_MAX + 1];
       msg (ME, _("%s variable %s has invalid format specifier %s."),
-           v->type == NUMERIC ? _("Numeric") : _("String"),
-           v->name, fmt_to_string (f, fmt_string));
-      *f = (v->type == NUMERIC
+           var_is_numeric (v) ? _("Numeric") : _("String"),
+           var_get_name (v), fmt_to_string (f, fmt_string));
+      *f = (var_is_numeric (v)
             ? fmt_for_output (FMT_F, 8, 2) 
-            : fmt_for_output (FMT_A, v->width, 0));
+            : fmt_for_output (FMT_A, var_get_width (v), 0));
     }
   return 1;
 
@@ -1356,10 +1362,10 @@ read_value_labels (struct sfm_reader *r,
                      "refers to a continuation of a string variable, not to "
                      "an actual variable."),
                fh_get_file_name (r->fh), var_idx));
-      if (v->type == ALPHA && v->width > MAX_SHORT_STRING)
+      if (var_is_long_string (v))
 	lose ((ME, _("%s: Value labels are not allowed on long string "
                      "variables (%s)."),
-               fh_get_file_name (r->fh), v->name));
+               fh_get_file_name (r->fh), var_get_name (v)));
 
       /* Add it to the list of variables. */
       var[i] = v;
@@ -1367,20 +1373,22 @@ read_value_labels (struct sfm_reader *r,
 
   /* Type check the variables. */
   for (i = 1; i < n_vars; i++)
-    if (var[i]->type != var[0]->type)
+    if (var_get_type (var[i]) != var_get_type (var[0]))
       lose ((ME, _("%s: Variables associated with value label are not all of "
                    "identical type.  Variable %s has %s type, but variable "
                    "%s has %s type."),
              fh_get_file_name (r->fh),
-	     var[0]->name, var[0]->type == ALPHA ? _("string") : _("numeric"),
-	     var[i]->name, var[i]->type == ALPHA ? _("string") : _("numeric")));
+	     var_get_name (var[0]),
+             var_is_alpha (var[0]) ? _("string") : _("numeric"),
+	     var_get_name (var[i]),
+             var_is_alpha (var[i]) ? _("string") : _("numeric")));
 
   /* Fill in labels[].value, now that we know the desired type. */
   for (i = 0; i < n_labels; i++) 
     {
       struct label *label = labels + i;
       
-      if (var[0]->type == ALPHA)
+      if (var_is_alpha (var[0]))
         {
           const int copy_len = MIN (sizeof label->raw_value,
                                     sizeof label->label);
@@ -1408,14 +1416,15 @@ read_value_labels (struct sfm_reader *r,
 	  if (!val_labs_replace (v->val_labs, label->value, label->label))
 	    continue;
 
-	  if (var[0]->type == NUMERIC)
+	  if (var_is_numeric (var[0]))
 	    msg (MW, _("%s: File contains duplicate label for value %g for "
                        "variable %s."),
-                 fh_get_file_name (r->fh), label->value.f, v->name);
+                 fh_get_file_name (r->fh), label->value.f, var_get_name (v));
 	  else
 	    msg (MW, _("%s: File contains duplicate label for value `%.*s' "
                        "for variable %s."),
-                 fh_get_file_name (r->fh), v->width, label->value.s, v->name);
+                 fh_get_file_name (r->fh), var_get_width (v),
+                 label->value.s, var_get_name (v));
 	}
     }
 
Index: src/data/sys-file-writer.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/sys-file-writer.c,v
retrieving revision 1.16
diff -u -p -r1.16 sys-file-writer.c
--- src/data/sys-file-writer.c	25 Nov 2006 02:15:00 -0000	1.16
+++ src/data/sys-file-writer.c	5 Dec 2006 06:36:38 -0000
@@ -114,13 +114,14 @@ static inline int
 var_flt64_cnt (const struct variable *v) 
 {
   assert(sizeof(flt64) == MAX_SHORT_STRING);
-  return width_to_bytes(v->width) / MAX_SHORT_STRING ;
+  return width_to_bytes(var_get_width (v)) / MAX_SHORT_STRING ;
 }
 
 static inline int
 var_flt64_cnt_nom (const struct variable *v) 
 {
-  return v->type == NUMERIC ? 1 : DIV_RND_UP (v->width, sizeof (flt64));
+  return (var_is_numeric (v)
+          ? 1 : DIV_RND_UP (var_get_width (v), sizeof (flt64)));
 }
 
 
@@ -215,9 +216,9 @@ sfm_open_writer (struct file_handle *fh,
     {
       const struct variable *dv = dict_get_var (d, i);
       struct sfm_var *sv = &w->vars[i];
-      sv->width = dv->width;
+      sv->width = var_get_width (dv);
       /* spss compatibility nonsense */
-      if ( dv->width > MAX_LONG_STRING ) 
+      if ( var_is_very_long_string (dv) ) 
 	  w->has_vls = true;
 
       sv->fv = dv->fv;
@@ -240,34 +241,32 @@ sfm_open_writer (struct file_handle *fh,
     {
       int count = 0;
       const struct variable *v = dict_get_var(d, i);
-      int wcount = v->width;
+      int wcount = var_get_width (v);
 
       do {
 	struct variable var_cont = *v;
-	if ( v->type == ALPHA) 
+	if ( var_is_alpha (v)) 
 	  {
 	    if ( 0 != count ) 
 	      {
-		mv_init(&var_cont.miss, 0);
-		strcpy(var_cont.short_name,
-		       cont_var_name(v->short_name, count));
-		var_cont.label = NULL;
+		var_clear_missing_values (&var_cont);
+                var_set_short_name (&var_cont,
+                                    cont_var_name (var_get_short_name (v),
+                                                   count));
+                var_clear_label (&var_cont);
 		w->var_cnt_vls++;
 	      }
 	    count++;
 	    if ( wcount > MAX_LONG_STRING ) 
 	      {
-		var_cont.width = MAX_LONG_STRING;
+                var_set_width (&var_cont, MAX_LONG_STRING);
 		wcount -= EFFECTIVE_LONG_STRING_LENGTH;
 	      }
 	    else
 	      {
-		var_cont.width = wcount;
-		wcount -= var_cont.width;
+		var_set_width (&var_cont, wcount);
+		wcount -= var_get_width (&var_cont);
 	      }
-	
-	    var_cont.write.w = var_cont.width;
-	    var_cont.print.w = var_cont.width;
 	  }
 
 	write_variable (w, &var_cont);
@@ -456,12 +455,13 @@ write_variable (struct sfm_writer *w, co
   struct missing_values mv;
   flt64 m[3];           /* Missing value values. */
   int nm;               /* Number of missing values, possibly negative. */
+  const char *label = var_get_label (v);
 
   sv.rec_type = 2;
-  sv.type = MIN(v->width, MAX_LONG_STRING);
-  sv.has_var_label = (v->label != NULL);
+  sv.type = MIN(var_get_width (v), MAX_LONG_STRING);
+  sv.has_var_label = label != NULL;
 
-  mv_copy (&mv, &v->miss);
+  mv_copy (&mv, var_get_missing_values (v));
   nm = 0;
   if (mv_has_range (&mv)) 
     {
@@ -474,22 +474,23 @@ write_variable (struct sfm_writer *w, co
     {
       union value value;
       mv_pop_value (&mv, &value);
-      if (v->type == NUMERIC)
+      if (var_is_numeric (v))
         m[nm] = value.f;
       else
-        buf_copy_rpad ((char *) &m[nm], sizeof m[nm], value.s, v->width);
+        buf_copy_rpad ((char *) &m[nm], sizeof m[nm], value.s,
+                       var_get_width (v));
       nm++;
     }
-  if (mv_has_range (&v->miss))
+  if (mv_has_range (var_get_missing_values (v)))
     nm = -nm;
 
   sv.n_missing_values = nm;
-  write_format_spec (&v->print, &sv.print);
-  write_format_spec (&v->write, &sv.write);
-  buf_copy_str_rpad (sv.name, sizeof sv.name, v->short_name);
+  write_format_spec (var_get_print_format (v), &sv.print);
+  write_format_spec (var_get_write_format (v), &sv.write);
+  buf_copy_str_rpad (sv.name, sizeof sv.name, var_get_short_name (v));
   buf_write (w, &sv, sizeof sv);
 
-  if (v->label)
+  if (label != NULL)
     {
       struct label
 	{
@@ -500,9 +501,9 @@ write_variable (struct sfm_writer *w, co
 
       int ext_len;
 
-      l.label_len = MIN (strlen (v->label), 255);
+      l.label_len = MIN (strlen (label), 255);
       ext_len = ROUND_UP (l.label_len, sizeof l.label_len);
-      memcpy (l.label, v->label, l.label_len);
+      memcpy (l.label, label, l.label_len);
       memset (&l.label[l.label_len], ' ', ext_len - l.label_len);
 
       buf_write (w, &l, offsetof (struct label, label) + ext_len);
@@ -511,7 +512,7 @@ write_variable (struct sfm_writer *w, co
   if (nm)
     buf_write (w, m, sizeof *m * abs (nm));
 
-  if (v->type == ALPHA && v->width > (int) sizeof (flt64))
+  if (var_is_alpha (v) && var_get_width (v) > (int) sizeof (flt64))
     {
       int i;
       int pad_count;
@@ -523,7 +524,7 @@ write_variable (struct sfm_writer *w, co
       memset (&sv.write, 0, sizeof sv.write);
       memset (&sv.name, 0, sizeof sv.name);
 
-      pad_count = DIV_RND_UP (MIN(v->width, MAX_LONG_STRING),
+      pad_count = DIV_RND_UP (MIN(var_get_width (v), MAX_LONG_STRING),
 			      (int) sizeof (flt64)) - 1;
       for (i = 0; i < pad_count; i++)
 	buf_write (w, &sv, sizeof sv);
@@ -649,15 +650,15 @@ write_variable_display_parameters (struc
 
       v = dict_get_var(dict, i);
 
-      params.measure = v->measure;
-      params.width = v->display_width;
-      params.align = v->alignment;
+      params.measure = var_get_measure (v);
+      params.width = var_get_display_width (v);
+      params.align = var_get_alignment (v);
       
       buf_write (w, &params, sizeof(params));
 
-      if ( v->width > MAX_LONG_STRING ) 
+      if (var_is_long_string (v))
 	{
-	  int wcount = v->width - EFFECTIVE_LONG_STRING_LENGTH ;
+	  int wcount = var_get_width (v) - EFFECTIVE_LONG_STRING_LENGTH ;
 
 	  while (wcount > 0) 
 	    {
@@ -698,10 +699,11 @@ write_vls_length_table (struct sfm_write
     {
       const struct variable *v = dict_get_var (dict, i);
       
-      if ( v->width <=  MAX_LONG_STRING ) 
+      if ( var_get_width (v) <=  MAX_LONG_STRING ) 
 	continue;
 
-      ds_put_format (&vls_length_map, "%s=%05d", v->short_name, v->width);
+      ds_put_format (&vls_length_map, "%s=%05d",
+                     var_get_short_name (v), var_get_width (v));
       ds_put_char (&vls_length_map, '\0');
       ds_put_char (&vls_length_map, '\t');
     }
@@ -739,7 +741,8 @@ write_longvar_table (struct sfm_writer *
       
       if (i)
         ds_put_char (&long_name_map, '\t');
-      ds_put_format (&long_name_map, "%s=%s", v->short_name, v->name);
+      ds_put_format (&long_name_map, "%s=%s",
+                     var_get_short_name (v), var_get_name (v));
     }
 
   lv_hdr.rec_type = 7;
Index: src/data/value-labels.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/value-labels.c,v
retrieving revision 1.9
diff -u -p -r1.9 value-labels.c
--- src/data/value-labels.c	5 Nov 2006 05:20:53 -0000	1.9
+++ src/data/value-labels.c	5 Dec 2006 06:36:38 -0000
@@ -546,8 +546,9 @@ value_to_string (const union value *val,
   if (s == NULL) 
     {
       static char buf[MAX_STRING + 1];
-      data_out (val, &var->print, buf);
-      buf[var->print.w] = '\0';
+      const struct fmt_spec *print = var_get_print_format (var);
+      data_out (val, print, buf);
+      buf[print->w] = '\0';
       s = buf;
     }
   
